// bitmap.cpp: implementation of the bitmap class.
//
//////////////////////////////////////////////////////////////////////

#include "bitmap.h"

/*****************************************************************************/
// Gets the colour at integer position x_pos, y_pos on from the bitmap
/*****************************************************************************/

colour bitmap::getColour(int x_pos, int y_pos)
{
	colour n;

	if (x_pos >= 0 && x_pos < x) {
		if (y_pos >= 0 && y_pos < y) {
			int index = (y_pos * x * planes) + (x_pos * planes);

			if (planes == 3) {
				n.r = bitmap_data[index];
				n.g = bitmap_data[index + 1];
				n.b = bitmap_data[index + 2];
				n.a = 255; }
			else {
				n.r = bitmap_data[index];
				n.g = bitmap_data[index];
				n.b = bitmap_data[index];
				n.a = 255; }
		} else cout << "ERROR: Y value is out of range!" << endl;
	} else cout << "ERROR: X value is out of range!" << endl;

	return n;
}

/*****************************************************************************/
// Gets the colour from parametric coordinates x_t and y_t
/*****************************************************************************/

colour bitmap::getColourf(float x_t, float y_t)
{
	colour n;
	int x_pos, y_pos;

	x_pos = x * x_t;
	x_pos = x_pos % x;

	y_pos = y * y_t;
	y_pos = y_pos % y;

	if (x_pos >= 0 && x_pos < x) {
		if (y_pos >= 0 && y_pos < y) {
			int index = (y_pos * x * planes) + (x_pos * planes);

			if (planes == 3) {
				n.r = bitmap_data[index];
				n.g = bitmap_data[index + 1];
				n.b = bitmap_data[index + 2];
				n.a = 255; }
			else {
				n.r = bitmap_data[index];
				n.g = bitmap_data[index];
				n.b = bitmap_data[index];
				n.a = 255; }
		} else cout << "ERROR: Y value is out of range!" << endl;
	} else cout << "ERROR: X value is out of range!" << endl;

	return n;
}

/*****************************************************************************/
// Puts colour c at position x_pos, y_pos
/*****************************************************************************/

void bitmap::putColour(int x_pos, int y_pos, colour c)
{
	if (x_pos >= 0 && x_pos < x) {
		if (y_pos >= 0 && y_pos < y) {
			int index = (y_pos * x * planes) + (x_pos * planes);

			if (planes == 3)
			{
				bitmap_data[index]     = c.r;
				bitmap_data[index + 1] = c.g;
				bitmap_data[index + 2] = c.b;
			} else {
//				int average((c.r + c.g + c.b) / 3);
//				if (average > 255) average = 255;
//				if (average < 0) average = 0;
				bitmap_data[index] = c.a;
			}
		} else cout << "ERROR: Y value is out of range!" << endl;
	} else cout << "ERROR: X value is out of range!" << endl;
}