#include "colour.h"

void colour::operator=(colour right)
{
	r = right.r;
	g = right.g;
	b = right.b;
	a = right.a;
}

colour colour::operator+(colour right)
{
	colour n;

	n.r = r + right.r;
	n.g = g + right.g;
	n.b = b + right.b;

	clamp();

	return n;
}

colour colour::operator-(colour right)
{
	colour n;

	n.r = r - right.r;
	n.g = g - right.g;
	n.b = b - right.b;

	clamp();

	return n;
}

colour colour::operator*(colour right)
{
	colour n;

	n.r = r * right.r;
	n.g = g * right.g;
	n.b = b * right.b;

	clamp();

	return n;
}

colour colour::operator/(colour right)
{
	colour n;

	n.r = r / right.r;
	n.g = g / right.g;
	n.b = b / right.b;

	clamp();

	return n;
}

colour colour::operator+(int right)
{
	colour n;

	n.r = r + right;
	n.g = g + right;
	n.b = b + right;

	clamp();

	return n;
}

colour colour::operator-(int right)
{
	colour n;

	n.r = r - right;
	n.g = g - right;
	n.b = b - right;

	clamp();

	return n;
}

colour colour::operator*(int right)
{
	colour n;

	n.r = r * right;
	n.g = g * right;
	n.b = b * right;

	clamp();

	return n;
}

colour colour::operator*(double right)
{
	colour n;

	n.r = r * right;
	n.g = g * right;
	n.b = b * right;

	clamp();

	return n;
}

colour colour::operator/(int right)
{
	colour n;

	n.r = r / right;
	n.g = g / right;
	n.b = b / right;

	clamp();

	return n;
}

unsigned char colour::operator==(colour right)
{
	if (r == right.r) {
		if (g == right.g) {
			if (b == right.b) {
				if (a == right.a) {
					return 1; } } } }
	return 0;
}

unsigned char colour::operator!=(colour right)
{
	return !(*this == right);
}

unsigned char colour::operator>=(colour right)
{
	int average1, average2;

	average1 = (r + g + b + a) / 4;
	average2 = (right.r + right.g + right.b + right.a) / 4;

	return (average1 >= average2);
}

unsigned char colour::operator<=(colour right)
{
	int average1, average2;

	average1 = (r + g + b + a) / 4;
	average2 = (right.r + right.g + right.b + right.a) / 4;

	return (average1 <= average2);
}

unsigned char colour::operator>(colour right)
{
	int average1, average2;

	average1 = (r + g + b + a) / 4;
	average2 = (right.r + right.g + right.b + right.a) / 4;

	return (average1 > average2);
}

unsigned char colour::operator<(colour right)
{
	int average1, average2;

	average1 = (r + g + b + a) / 4;
	average2 = (right.r + right.g + right.b + right.a) / 4;

	return (average1 < average2);
}

void colour::clamp(void)
{
	if (r < 0) r = 0;

	if (r > 255) r = 255;

	if (g < 0) g = 0;

	if (g > 255) g = 255;

	if (b < 0) b = 0;

	if (b > 255) b = 255;

	if (a < 0) a = 0;

	if (a > 255) a = 255;
}