// matrix.cpp: implementation of the matrix class.
//
//////////////////////////////////////////////////////////////////////

#include "matrix.h"

matrix matrix::operator+(matrix right)
{
	matrix n;

	for (int i = 0; i < 4; i++) {
		for (int j = 0; j < 4; j++) {
			n.m[i*4+j] = m[i*4+j] + right.m[i*4+j]; } }

	return n;
}

matrix matrix::operator-(matrix right)
{
	matrix n;

	for (int i = 0; i < 4; i++) {
		for (int j = 0; j < 4; j++) {
			n.m[i*4+j] = m[i*4+j] - right.m[i*4+j]; } }

	return n;
}

matrix matrix::operator*(double right)
{
	matrix n;

	for (int i = 0; i < 4; i++) {
		for (int j = 0; j < 4; j++) {
			n.m[i*4+j] = m[i*4+j] * right; } }

	return n;
}

matrix matrix::operator*(matrix right)
{
	matrix n;

	for (int i = 0; i < 4; i++) {
		for (int j = 0; j < 4; j++) {
			n.m[i*4+j] = 0;
			for (int k = 0; k < 4; k++) {
				n.m[i*4+j] += m[i*4+k] * right.m[k*4+j]; } } }

	return n;
}

matrix matrix::operator-(void)
{
	matrix n;

	for (int i = 0; i < 4; i++) {
		for (int j = 0; j < 4; j++) {
			n.m[i*4+j] = m[j*4+i]; } }

	return n;
}

ostream& operator<<(ostream &output, matrix n)
{
	output << endl;

	for (int j = 0; j < 4; j++) {
		output << "| ";
		for (int i = 0; i < 4; i++) {
			output << n.m[i*4+j] << (i == 3 ? " |" : " "); }
		output << endl; }

	return output;
}

matrix translate(vector direction)
{
	matrix n;

	n.m[12] = direction.x;
	n.m[13] = direction.y;
	n.m[14] = direction.z;
	n.m[15] = direction.w;

	return n;
}

matrix translate(double x, double y, double z)
{
	matrix n;

	n.m[12] = x;
	n.m[13] = y;
	n.m[14] = z;

	return n;
}

matrix scale(vector size)
{
	matrix n;

	n.m[0]  = size.x;
	n.m[5]  = size.y;
	n.m[10] = size.z;
	n.m[15] = size.w;

	return n;
}

matrix scale(double x, double y, double z)
{
	matrix n;

	n.m[0]  = x;
	n.m[5]  = y;
	n.m[10] = z;

	return n;
}

matrix aimx(vector direction)
{
	matrix n;
	vector x1, x2, x3, up;

	up.x = 0;
	up.y = 1;
	up.z = 0;

	x1 = direction.normalised();

	if (up == x1) {
		up.x = 1;
		up.y = 0;
		up.z = 0; }

	x2 = up % x1;
	x2.normalise();
	x3 = x1 % x2;
	x3.normalise();

	n.m[0]  = x1.x;
	n.m[1]  = x1.y;
	n.m[2]  = x1.z;

	n.m[4]  = x2.x;
	n.m[5]  = x2.y;
	n.m[6]  = x2.z;

	n.m[8]  = x3.x;
	n.m[9]  = x3.y;
	n.m[10] = x3.z;

	return n;
}

matrix rotate(vector angle, vector axis)
{
	matrix n;

	return n;
}