object* loadOBJfile(char *file_name, int x, int y)
{
	object *new_object;
	FILE *object_file;

	object_file = fopen(file_name, "rb");

	if (object_file != NULL)
	{
		new_object = new object(x, y);

		if (new_object != NULL)
		{
			int vertex_count(0), uv_count(0), normals_count(0), polygon_count(0), include_normals(0);
			char string[1000], v1[100], v2[100], v3[100];

			fseek(object_file, 0, SEEK_SET);

			while (!feof(object_file))
			{
				fscanf(object_file, "%s", string);

				if (strcmp(string, "v") == 0) vertex_count++;
				if (strcmp(string, "vt") == 0) uv_count++;
				if (strcmp(string, "vn") == 0) normals_count++;
				if (strcmp(string, "f") == 0) polygon_count++;
			}

			new_object->vertices = new vector[vertex_count];
			new_object->uvs = new vector[uv_count];
			new_object->normals = new vector[normals_count];
			new_object->polygons = new polygon[polygon_count];

			new_object->vertex_count = vertex_count;
			new_object->uv_count = uv_count;
			new_object->normals_count = normals_count;
			new_object->polygon_count = polygon_count;

			cout << "Object Data: " << endl << endl;
			cout << "FILE NAME: " << file_name << endl;
			cout << "VERTICES: " << vertex_count << endl;
			cout << "UVS: " << uv_count << endl;
			cout << "NORMALS: " << normals_count << endl;
			cout << "POLYGONS: " << polygon_count << endl << endl;

			if (normals_count > 0) include_normals = 1;

			vertex_count = 0;
			uv_count = 0;
			normals_count = 0;
			polygon_count = 0;

			fseek(object_file, 0, SEEK_SET);

			while (!feof(object_file))
			{
				fscanf(object_file, "%s", string);

				if (strcmp(string, "v") == 0)
				{
					fscanf(object_file, "%s %s %s", v1, v2, v3);
					new_object->vertices[vertex_count](atof(v1), atof(v2), atof(v3));

					vertex_count++;
				}

				if (strcmp(string, "vt") == 0)
				{
					fscanf(object_file, "%s %s", v1, v2);
					new_object->uvs[uv_count](atof(v1), atof(v2));

					uv_count++;
				}

				if (strcmp(string, "vn") == 0)
				{
					fscanf(object_file, "%s %s %s", v1, v2, v3);
					new_object->normals[normals_count](atof(v1), atof(v2), atof(v3));

					normals_count++;
				}

				if (strcmp(string, "f") == 0 && polygon_count < new_object->polygon_count)
				{
					fscanf(object_file, "%s %s %s", v1, v2, v3);

					if (include_normals != 0)
					{
						int a, b, c;

						sscanf(v1, "%d/%d/%d", &a, &b, &c);

						new_object->polygons[polygon_count].vertex1 = new_object->vertices[a-1];
						new_object->polygons[polygon_count].uv1 = new_object->uvs[b-1];
						new_object->polygons[polygon_count].normal1 = new_object->normals[c-1];

						sscanf(v2, "%d/%d/%d", &a, &b, &c);

						new_object->polygons[polygon_count].vertex2 = new_object->vertices[a-1];
						new_object->polygons[polygon_count].uv2 = new_object->uvs[b-1];
						new_object->polygons[polygon_count].normal2 = new_object->normals[c-1];

						sscanf(v3, "%d/%d/%d", &a, &b, &c);

						new_object->polygons[polygon_count].vertex3 = new_object->vertices[a-1];
						new_object->polygons[polygon_count].uv3 = new_object->uvs[b-1];
						new_object->polygons[polygon_count].normal3 = new_object->normals[c-1];
 					} else {
						int a, b;

						sscanf(v1, "%d/%d", &a, &b);

						new_object->polygons[polygon_count].vertex1 = new_object->vertices[a-1];
						new_object->polygons[polygon_count].uv1 = new_object->uvs[b-1];

						sscanf(v2, "%d/%d", &a, &b);

						new_object->polygons[polygon_count].vertex2 = new_object->vertices[a-1];
						new_object->polygons[polygon_count].uv2 = new_object->uvs[b-1];

						sscanf(v3, "%d/%d", &a, &b);

						a--;
						b--;

						if (a < new_object->vertex_count)
							new_object->polygons[polygon_count].vertex3 = new_object->vertices[a];
						else cout << "ERROR: Vertex index is out of range!" << endl;

						if (b < new_object->uv_count)
							new_object->polygons[polygon_count].uv3 = new_object->uvs[b];
						else cout << "ERROR: UV index is out of range!" << endl;
					}
					vector vec1, vec2;
					vec1 = new_object->polygons[polygon_count].vertex2 - new_object->polygons[polygon_count].vertex1;
					vec2 = new_object->polygons[polygon_count].vertex3 - new_object->polygons[polygon_count].vertex1;
					new_object->polygons[polygon_count].plane_normal = vec1 % vec2;
					new_object->polygons[polygon_count].plane_normal.normalise();

					polygon_count++;
				}
			}
			cout << "Object '" << file_name << "' loaded successfully" << endl;
		} else cout << "ERROR: New object could not be created!" << endl;
	} else cout << "ERROR: OBJ file '" << file_name << "' could not be opened!" << endl;

	return new_object;
}
