#ifndef _VECTOR_H_
#define _VECTOR_H_

//class vector;

#include "matrix.h"

class vector {
public:
	vector(double = 0.0, double = 0.0, double = 0.0);
	virtual ~vector();

	inline double mag(void);
	vector normalised(void);
	inline void normalise(void);
	inline void setlength(double = 1.0);

	vector operator-();

	vector operator+(vector);
	vector operator-(vector);
	vector operator*(vector);
	vector operator/(vector);

	vector operator+(double);
	vector operator-(double);
	vector operator*(double);
	vector operator/(double);

	vector operator*(matrix);
	vector operator%(vector);

	void operator+=(vector);
	void operator-=(vector);
	void operator*=(vector);
	void operator/=(vector);

	void operator+=(double);
	void operator-=(double);
	void operator*=(double);
	void operator/=(double);

	void operator()(double = 0.0, double = 0.0, double = 0.0);

	friend ostream &operator<<(ostream&, vector);

	unsigned char operator==(vector);
	unsigned char operator!=(vector);

	double x, y, z, w;
};

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

vector::vector(double X, double Y, double Z)
{
	x = X;
	y = Y;
	z = Z;
	w = 1.0;
}

vector::~vector()
{
	// delete vector class here
}

#endif